#include <stdio.h>

#define SAFE 0
#define UNSAFE 1
#define ALIENBASE 2

int main() {
    int cityCnt;
    int roadCnt;
    int alienCnt;
    int safeDistance;
    
    int safeCities;
    
    int i;
    int a, b, c, d;
    int tmp;
    
    int originalRoads[100001][3];
    
    int cityRoadsCnt[10001];
    
    int * cityRoads[10001];
    char cityState[10001];
    
    int subState[10001];
    int subDist[10001];
    
    for(i=0;i<10001; i++) {
        cityRoadsCnt[i]=0;
        cityRoads[i]=NULL;
    }
    
    
    while(1) {
        scanf("%d %d %d %d", &cityCnt, &roadCnt, &alienCnt, &safeDistance);
        if(cityCnt==0 && roadCnt==0 && alienCnt==0 && safeDistance==0) break;
        
        safeCities=cityCnt;
        
        for(i=0;i<100001;i++)
            originalRoads[i][0]=originalRoads[i][1]=originalRoads[i][2]=0;
        
        for(i=0;i<10001;i++) {
            if(cityRoadsCnt[i]) {
                cityRoadsCnt[i]=0;
                delete [] cityRoads[i];
                cityRoads[i]=NULL;
            }
            cityState[i]=SAFE;
        }
        
        for(i=0;i<roadCnt;i++) {
            scanf("%d %d %d", &a, &b, &c);
            originalRoads[i][0]=a;
            originalRoads[i][1]=b;
            originalRoads[i][2]=c;
            cityRoadsCnt[a]++;
            cityRoadsCnt[b]++;
        }
        
        for(i=1;i<=cityCnt;i++) {
            //fprintf(stderr,"[%d:%d]",i,cityRoadsCnt[i]); //debug
            if (cityRoadsCnt[i]==0) {continue;}
            cityRoads[i] = new int [cityRoadsCnt[i]+cityRoadsCnt[i]+1];
            cityRoads[i][0] = 0;
        }
        
        for(i=0;i<roadCnt;i++) {
            a = originalRoads[i][0];
            b = originalRoads[i][1];
            c = originalRoads[i][2];
            tmp = cityRoads[a][0];
            cityRoads[a][++tmp]=b;
            cityRoads[a][++tmp]=c;
            cityRoads[a][0]=tmp;
            tmp = cityRoads[b][0];
            cityRoads[b][++tmp]=a;
            cityRoads[b][++tmp]=c;
            cityRoads[b][0]=tmp;
        }
        
        while(alienCnt--) {
            scanf("%d", &a);
            if(cityState[a]==SAFE) safeCities--;
            cityState[a]=ALIENBASE;
            
            for(i=0;i<10001;i++) {
                subState[i]=0;
                subDist[i]=101;
            }
            
            subState[a] = 1;
            subDist[a]=0;
            while(1) {
                a=-1;
                b=101;
                for(i=1;i<cityCnt;i++) {
                    if(subState[i]==1) {
                        if(subDist[i]<=b) {
                            a=i;
                            b=subDist[a];
                        }
                    }
                }
                
                if(b>=safeDistance) break;
                
                subState[a]=2;
                if(cityState[a]==SAFE) {
                    cityState[a]=UNSAFE;
                    safeCities--;
                }
                for(i=0;i<cityRoadsCnt[a];i++) {
                    c = cityRoads[a][i+i+2]+b;
                    if(c>=safeDistance) continue;
                    d = cityRoads[a][i+i+1];
                    if(subDist[d]>c) subDist[d]=c;
                    if(!subState[d]) subState[d]=1;
                }
            }
            
            printf("%d\n", safeCities);
         }
         puts("");
     }
     
     return 0;
 }
